﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using JetairTours.Business;
using JetairTours.DataAccess;
using JetairTours.DataLayer;
using JetairTours.General;
using System.Web.UI.WebControls.WebParts;
using System.Data;
using System.Text;
using AjaxPro;
using Excel = Microsoft.Office.Interop.Excel;
using System.Data.SqlClient;
using System.IO;
using WebApplication1;
using System.Collections;

public partial class Reports_Booking_status : System.Web.UI.Page
{
   
    protected void Page_Load(object sender, EventArgs e)
    {
        this.UserButtons1.Click += new User_Controls_UserButtons.ClickEventHandler(btn_Goclick);
        Utility.RegisterTypeForAjax(typeof(Reports_Booking_status));      
        UserButtons1.GetButton(false, false, false, false, false, true, true, false, false, true);
        if (hdnCorporate.Value != "")
        {
            auto_extender.ContextKey = hdnCorporate.Value;
            auto_extender.MinimumPrefixLength = 1;
        }
       
        if (!IsPostBack)
        {
            //Default_grid();
        }
        txtcorpname.Focus();
       
    }
   
    public bool get_booking_status()
    {
        DataTable dtbookingdt = new DataTable();
        SqlDataAdapter dabookingstatus;
        DataSet dsbooking_status = new DataSet();
        SqlCommand objCommand = new SqlCommand();
        
        List<string> file_name = new List<string>();

        dabookingstatus = new SqlDataAdapter(objCommand);
        dabookingstatus.SelectCommand.CommandType = CommandType.StoredProcedure;
        objCommand.CommandText = "usp_get_booking_status";
        try
        {
            objCommand.Parameters.AddWithValue("@p_corporate_id", hdnCorporate.Value.Trim() == "" ? "" : hdnCorporate.Value.Trim());
            objCommand.Parameters.AddWithValue("@p_booking_id", txtbookid.Text.Trim());
            DataBaseHandler objhandler = new DataBaseHandler();
            objhandler.ExecuteProcedure(objCommand);
            dabookingstatus.Fill(dsbooking_status);
            dsbooking_status.Tables[0].TableName = "Booking Detail";
            if (dsbooking_status.Tables[0].Rows.Count > 0)
            {
                dsbooking_status.Tables[0].TableName = "Booking Detail";
               
                lblbook_id.Text = dsbooking_status.Tables[0].Rows[0]["Booking No"].ToString();
                lblbook_date.Text = dsbooking_status.Tables[0].Rows[0]["Booking Date"].ToString();
                lblpax_nos.Text = dsbooking_status.Tables[0].Rows[0]["Nos of Pax"].ToString();
                lbltraveller_name.Text = dsbooking_status.Tables[0].Rows[0]["Traveller Name"].ToString();
                lbltour_type.Text = dsbooking_status.Tables[0].Rows[0]["Tour Type"].ToString();
                lblzone_name.Text = dsbooking_status.Tables[0].Rows[0]["Destination Group"].ToString();
                lbldest_name.Text = dsbooking_status.Tables[0].Rows[0]["Destination"].ToString();
                lblserv_name.Text = dsbooking_status.Tables[0].Rows[0]["Services"].ToString();
                lblpackage_name.Text = dsbooking_status.Tables[0].Rows[0]["Package Name"].ToString();
                if (lblpackage_name.Text.ToString() != "")
                {
                    StringBuilder sbScript = new StringBuilder();
                    sbScript.Append("<script language='javascript' type='text/javascript'>");
                    sbScript.Append(Environment.NewLine);
                    sbScript.Append("getpackagename();");
                    sbScript.Append(Environment.NewLine);
                    sbScript.Append("</script>");
                    Page.Controls.Add(new LiteralControl(sbScript.ToString()));
                    lblpackage_name.Text = dsbooking_status.Tables[0].Rows[0]["Package Name"].ToString();
                }

                lbltravdate.Text = dsbooking_status.Tables[0].Rows[0]["Traveller from Date"].ToString();
                lbljp_no.Text = dsbooking_status.Tables[0].Rows[0]["jp no"].ToString();
                lblbook_loc.Text = dsbooking_status.Tables[0].Rows[0]["Booking Location"].ToString();
                lblbook_status.Text = dsbooking_status.Tables[0].Rows[0]["Status"].ToString();
                lblcorp_name.Text = dsbooking_status.Tables[0].Rows[0]["Corporate Name"].ToString();
                lbltraveltodate.Text = dsbooking_status.Tables[0].Rows[0]["Traveller to Date"].ToString();
                ViewState["Data"] = dsbooking_status;
                ViewState["booking"] = dsbooking_status.Tables[0];

              //Cost Sheet Details
                dsbooking_status.Tables[1].TableName = "Cost Sheet Detail";
                if (dsbooking_status.Tables[1].Rows.Count > 0)
                {
                    for (int j = 0; j < dsbooking_status.Tables[1].Rows.Count; j++)
                    {

                        grdcost_sheet.DataSource = dsbooking_status.Tables[1];
                        grdcost_sheet.DataBind();
                        ViewState["Data"] = dsbooking_status;
                    }
                 }
                else
                {
                    DataRow dr1 = dsbooking_status.Tables[1].NewRow();
                    dr1["Currncy Name"] = "Cost Sheet not Available";
                    dsbooking_status.Tables[1].Rows.Add(dr1);
                    grdcost_sheet.DataSource = dsbooking_status.Tables[1];
                    grdcost_sheet.DataBind();
                }
               
                //Invoice Details
                dsbooking_status.Tables[2].TableName = "Invoice Details";
                if (dsbooking_status.Tables[2].Rows.Count > 0)
                {
                    
                    for (int j = 0; j < dsbooking_status.Tables[2].Rows.Count; j++)
                    {

                        grdinvoice_dtls.DataSource = dsbooking_status.Tables[2];
                         grdinvoice_dtls.DataBind();
                         ViewState["Data"] = dsbooking_status;
                      
                    }
                }
                else
                {
                    DataRow dr = dsbooking_status.Tables[2].NewRow();
                    dr["Invoice Nos"] = "Invoice Details not Available";
                    dsbooking_status.Tables[2].Rows.Add(dr);
                    grdinvoice_dtls.DataSource = dsbooking_status.Tables[2];
                    grdinvoice_dtls.DataBind();
                }
                //Payment Details
                dsbooking_status.Tables[3].TableName = "Payment Details";
                if (dsbooking_status.Tables[3].Rows.Count > 0)
                {
                    for (int j = 0; j < dsbooking_status.Tables[3].Rows.Count; j++)
                    {

                        grdpayment_dtls.DataSource = dsbooking_status.Tables[3];
                        grdpayment_dtls.DataBind();
                        ViewState["Data"] = dsbooking_status;
                    }
                }
                else
                {
                    DataRow dr2 = dsbooking_status.Tables[3].NewRow();
                    dr2["Doc Type"] = "Payment Details not Available";
                    dsbooking_status.Tables[3].Rows.Add(dr2);
                    grdpayment_dtls.DataSource = dsbooking_status.Tables[3];
                    grdpayment_dtls.DataBind();
                }
                //DnCn Details
                dsbooking_status.Tables[4].TableName = "DNCN Detail";
                if (dsbooking_status.Tables[4].Rows.Count > 0)
                {
                    for (int j = 0; j < dsbooking_status.Tables[4].Rows.Count; j++)
                    {

                        Grddncn_dtls.DataSource = dsbooking_status.Tables[4];
                        Grddncn_dtls.DataBind();
                        ViewState["Data"] = dsbooking_status;
                    }
                }
                else
                {
                    DataRow dr3 = dsbooking_status.Tables[4].NewRow();
                    dr3["Doc Type"] = "DNCN Details not Available";
                    dsbooking_status.Tables[4].Rows.Add(dr3);
                    Grddncn_dtls.DataSource = dsbooking_status.Tables[4];
                    Grddncn_dtls.DataBind();
                }
                return true;
            }
          
            else
            {
                Clear_Control();
                //return sb.ToString();
                //StringBuilder sbScript = new StringBuilder();
                //sbScript.Append("<script language='javascript' type='text/javascript'>");
                //sbScript.Append(Environment.NewLine);
                //sbScript.Append("alert('No Data to display');");
                //sbScript.Append(Environment.NewLine);
                //sbScript.Append("</script>");
                //Page.Controls.Add(new LiteralControl(sbScript.ToString()));
             
                return false;
            }
       
        }
          
        catch (Exception ex)
        {
            throw new Exception(ex.Message);

        }
        finally
        {
           
        }
       
    
    }
    private void Clear_Control()
    {
        //Default_grid();
        lblbook_id.Text = "";
        lblbook_date.Text = "";
        lblbook_loc.Text = "";
        lblbook_status.Text = "";
        lblpax_nos.Text = "";
        lblcorp_name.Text = "";
        lbldest_name.Text = "";
        lblserv_name.Text = "";
        lbltraveller_name.Text = "";
        lbltour_type.Text = "";
        lblzone_name.Text = "";
        lblpackage_name.Text = "";
        lbltravdate.Text = "";
        lbljp_no.Text = "";
        lbltraveltodate.Text = "";
      
    }
    private void Default_grid()
    {
        DataTable dtbkstatus = new DataTable();
        DataTable dtbkstatus1 = new DataTable();
        DataTable dtbkstatus2 = new DataTable();
        DataTable dtbkstatus3 = new DataTable();

        dtbkstatus.Columns.Add("Cost Sheet Nos");
        dtbkstatus.Columns.Add("Supplier Name");
        dtbkstatus.Columns.Add("Currncy Name");
        dtbkstatus.Columns.Add("Received Quote");
        dtbkstatus.Columns.Add("Service Tax");
        dtbkstatus.Columns.Add("Supplier Cost");
        dtbkstatus.Columns.Add("Cost to Customer");
        dtbkstatus.Columns.Add("Currency Name");
        dtbkstatus.Columns.Add("Margin");
        dtbkstatus.Columns.Add("Margin amt");
        dtbkstatus.Columns.Add("Cost");
        dtbkstatus.Columns.Add("Tax Percent");
        dtbkstatus.Columns.Add("Tax");
         
        DataRow dr = dtbkstatus.NewRow();
        dr["Supplier Name"] = "Cost Sheet Details not available";
        dtbkstatus.Rows.Add(dr);
        grdcost_sheet.DataSource = dtbkstatus;
        grdcost_sheet.DataBind();

        dtbkstatus1.Columns.Add("Invoice Nos");
        dtbkstatus1.Columns.Add("Invoice Amt");
        dtbkstatus1.Columns.Add("Invoice Service Tax Amt");
        dtbkstatus1.Columns.Add("Invoice Total Amt");


        DataRow dr1 = dtbkstatus1.NewRow();
        dr1["Invoice Amt"] = "Invoice Details not available";
        dtbkstatus1.Rows.Add(dr1);
        grdinvoice_dtls.DataSource = dtbkstatus1;
        grdinvoice_dtls.DataBind();



        dtbkstatus2.Columns.Add("Adjustment Nos");
        dtbkstatus2.Columns.Add("Adjustment Amt");
        dtbkstatus2.Columns.Add("Doc Type");
        dtbkstatus2.Columns.Add("Account Type");
        dtbkstatus2.Columns.Add("Invoice No");
        DataRow dr2 = dtbkstatus2.NewRow();
        dr2["Adjustment Amt"] = "Payment Details not available";
        dtbkstatus2.Rows.Add(dr2);
        grdpayment_dtls.DataSource = dtbkstatus2;
        grdpayment_dtls.DataBind();

        dtbkstatus3.Columns.Add("Adjustment Nos");
        dtbkstatus3.Columns.Add("Adjustment Amt");
        dtbkstatus3.Columns.Add("Doc Type");
        dtbkstatus3.Columns.Add("Account Type");
        dtbkstatus3.Columns.Add("Invoice No");
        DataRow dr3 = dtbkstatus3.NewRow();
        dr3["Adjustment Amt"] = "DnCn Details not available";
        dtbkstatus3.Rows.Add(dr3);
        Grddncn_dtls.DataSource = dtbkstatus3;
        Grddncn_dtls.DataBind();

    }
    private void btn_Goclick(object sender, EventArgs e, string Itemtag)
    {

        switch (Itemtag)
        {
            case "Go":

                if (get_booking_status() == true)
                {

                    get_booking_status();
                }
                else
                {

                    StringBuilder sbScript = new StringBuilder();
                    sbScript.Append("<script language='javascript' type='text/javascript'>");
                    sbScript.Append(Environment.NewLine);
                    sbScript.Append("alert('No Data to display');");
                    sbScript.Append(Environment.NewLine);
                    sbScript.Append("</script>");
                    Page.Controls.Add(new LiteralControl(sbScript.ToString()));
                   
                }
                
                break;
            case "Cancel":
                Response.Redirect("~/Default.aspx");
                break;
            case "Export TO Excel":
                {
                    
                    //DataSet dss = new DataSet();
                    //dss = (DataSet)ViewState["Data"];
                    ////ExcelHelper.ToExcel(dss, "BookingStatus.xls", Page.Response);
                    //if (get_booking_status() == true)
                    //{
                    //    ExcelHelper.ToExcel(dss, "BookingStatus.xls", Page.Response);
                    //}
                    //else
                    //{

                    //    StringBuilder sbScript1 = new StringBuilder();
                    //    sbScript1.Append("<script language='javascript' type='text/javascript'>");
                    //    sbScript1.Append(Environment.NewLine);
                    //    sbScript1.Append("alert('No Data to Export');");
                    //    sbScript1.Append(Environment.NewLine);
                    //    sbScript1.Append("</script>");
                    //    Page.Controls.Add(new LiteralControl(sbScript1.ToString()));
                    //}
                    break;
                }
        }
    }
    //[System.Web.Services.WebMethod]
    //public static string Message()
    //{   
    //    return "Hello from the server-side World!";
    //}
    
}